;====================================================================
; Project:		GUIw512 Sample ScrollBar
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	     
;				    
;                   
;====================================================================

Include "..\X3D_include\Xors3D.bb"

xGraphics3D 800,600,32,0
xSetBuffer xBackBuffer()

;	----------===  GUI ===----------
Include "..\X3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\X3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

xSetFont xLoadFont ("Tahoma",16)

Local window%,scroll_1%,scroll_2%,scroll_3%,scroll_4%

;	----------===   ===----------
window=WG_CreateWindow(450,150,200,300,"",0,1,1,1)

;	----------===    ===----------

; WG_CreateScrollBar% (parent%, x%, y%, length%, sliderLen# [,direction%=1] [,min%=0]
;			[,max%=100] [,value%=0] [,Style%=0] [,flag%=1] [,width%=WGV_ScrollBarWidth])
;		:
; parent% -    (,    ..). 
; x%, y% -   . 
; length% -   . 
; sliderLen# -  .
; direction% (.) - : 
;		0 - - 
;		1 - - 
;		2 - - 
;		3 - - 
; min% (.) -  . 
; max% (.) -  . 
; value% (.) -  . 
; Style% (.) -   . 
; flag% (.) - : ( : 1) 
;		0 -   
;		1 -   
;		2 -    
;		4 -      
;		8 -          
; width% (.) -   .    WGV_ScrollBarWidth
;		:
;        . 
;         
;  . ..        
;   scale# (),     . 
;          WG_SetScrollBarMarking(),
; WG_SetScrollBarMarkingPart()    WG_SetScrollBarScale()

;   ; : 1+2
scroll_1=WG_CreateScrollBar(window,20,50,140,9,0,-90,90,60,0,3)
;   ; : 2+4;  1
scroll_2=WG_CreateScrollBar(window,20,80,140,15,3,60,190,100,1,6)
;   ; : 1+2
scroll_3=WG_CreateScrollBar(window,70,130,140,9,1,-90,90,60,0,3)
;   ; : 2+4;  1
scroll_4=WG_CreateScrollBar(window,100,130,140,15,2,-90,90,60,1,6)

;  4     0.05
WG_SetScrollBarScale(scroll_4,.05)

;      
WG_SetElementTextAlign(scroll_1,4)
WG_SetElementTextAlign(scroll_2,4)
;     
WG_SetElementTextAlign(scroll_3,2)
WG_SetElementTextAlign(scroll_4,2)

;	----------===   ===----------

;	----------===  WG_SetScrollBarMarking ===----------

; WG_SetScrollBarMarking(ScrollBar%, mStep% [,mTextStep%=0] [,mShift%=0] [,mTextShift%=0] [,mText%=1] [,scale#=1.0])
;		:
; ScrollBar% -    .
; mStep% -  .    .
; mTextStep% (.) -  .  ,    
;	 .  0,     .
; mShift% (.) -     ,   
;	 minVal+mShift,  minVal -    .
; mTextShift% (.) -    ,    0.
; mText% (.) -  :
;		0 - ;
;		1 - .
; scale# -  (  WG_SetScrollBarScale())
;		:
;     .

;        30     
WG_SetScrollBarMarking(scroll_1,30,1)

;    ,      25  
;  50,     25 (mStep=25)    
;  (mTextStep=1). ..    60,    
;   75     15 (mShift=15),   
;    75,   100        (mTextShift=1)
WG_SetScrollBarMarking(scroll_2,25,1,15,1)

;	----------===  WG_SetScrollBarMarkingPart ===----------

; WG_SetScrollBarMarkingPart (ScrollBar%, partCount% [,textStep%=0] [,textShift%=0] [,mText%=True] [,scale#=1.0])
;		:
; ScrollBar% -    . 
; partCount% -  ,     . 
; textStep% (.) -   : 0 -  , 1 -    .. 
; textShift% (.) -  ,     
;	 (0 -    ). 
; mText% (.) - / . 
; scale# (.) -  . (  WG_SetScrollBarScale())
;		:
;    .

;   12 ,   4 
WG_SetScrollBarMarkingPart(scroll_3,12,3)
;   18 ,   3 
WG_SetScrollBarMarkingPart(scroll_4,18,2)

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
While xKeyHit(1)=0
	
;	----------=== xRenderWorld ===----------
	xRenderWorld
	
;	----------=== UpDate GUI ===----------
	xStartDraw()
	
	GUIw512_UpDate()
	
	xEndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
	;	----------===     ===----------
		Case WGV_EventScrollBarScrolling
			
		;	----------===  ScrollBar     ===----------
			Select WG_EventSource()
					
			;	----------===      ===----------
				Case scroll_1
					; - 
					value=WG_EventData()	; -    
					state=WG_EventState()	; -    
					
;					   (ScrollBar): 
;				WGV_StateMoveStart -   . 
;				WGV_StateMoving -   . 
;				WGV_StateMoveEnd -   . 
;				-1 -      
;				1 -      
;
;				    WG_EventData()   
;				 ,      .
					
			;	----------===      ===----------
				Case scroll_2
					;  .. ...
			End Select
	End Select
	
;	----------===  FPS ===----------
	xColor 100,100,100
	xText xGraphicsWidth() Shr 1,10,WGV_FPS,1
	
	xFlip
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=xCreateLight()
	xRotateEntity light,45,-60,0
	cam=xCreateCamera()
	xCameraClsColor cam,10,20,30
	xCameraZoom cam,.3
	cub=xCreateCube()
	xRotateEntity cub,-10,-20,-10
	tex=xLoadTexture("..\media\LogoTex.png")
	xEntityTexture cub,tex
	xPositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D